// The Swift Programming Language
// https://docs.swift.org/swift-book

import Alamofire
import Foundation

public final class BaseNetworkService: BaseNetworkServiceProtocol {
    
    public var baseURL: String?
    
    public func execute(path: String, method: HTTPMethod, headers: HTTPHeaders, parameters: Parameters) async throws -> Data {
        guard let baseURL = baseURL else {
            fatalError("Error baseURL")
        }
        
        let stringURL = baseURL + "/" + path
        
        let data = try await AF.request(stringURL, method: method, parameters: parameters, encoding: JSONEncoding.default, headers: headers).serializingData().value
        
        return data
        
    }
    
    public func configure(baseURL: String) {
        self.baseURL = baseURL
    }
    
    
}
